;MiniShell by chicane
;version .6
#include "asm86.h"
#include "ti86asm.inc"
#include "ti86ops.inc"

_clrText                equ     $4AB5
_mov10frop1             equ     $42E3
_mov10toop1     		equ     $42D7

.org _asm_exec_ram
	nop
	jp  ASMstart
	.dw $0000
	.dw PrgmName

ASMstart:
	res 	1,(iy+$0D)
	call    BUSY_OFF
	call    _clrLCD
	call    _clrScrn
	call    _clrText
	call    clrPlot
    ld		hl,AbsFirst
	call	_mov10toop1
	call	NextPrgm
	call	DisplayP
	call    Display
	call	DispBox
		jp      GetKey1

Display:
	ld      hl,$0001
	ld      (_penCol), hl
	ld      hl,PrgmName
	call    _vputs
	
	ld      a,$58
	ld      (_penCol),a
	ld      hl,Version
	call    _vputs
	
	ld      hl,$3A19
	ld      (_penCol),hl
	ld      hl,EMail
	call    _vputs
	
	ld      hl,$FFA0
	call    Invert
	ld      hl,$FC00
	call    Invert
	ret

DispBox:
	set		3,(iy+5)
	ld		hl,$0302
	ld		(_curRow),hl
	ld		hl,PrgmsMenu
	call	_puts
	res		3,(iy+5)
	ret

GetKey1:
	call    GET_KEY
	cp      K_NOKEY
	jr      z,GetKey1
	cp      K_EXIT
	jp      z,Exit
	cp      K_UP
	call    z,LastPrgm
	cp      K_DOWN
	call    z,NextPrgm
	cp      K_PLUS
	jp      z,ContUp
	cp      K_MINUS
	jp      z,ContDown
	cp      K_CLEAR
	jp      z,ShutOff
	cp		K_ENTER
	jp		z,Exec
	jp      GetKey1


ContUp:       
	ld      a,($C008)
	inc     a
	ld      ($C008),a
	out     (2),a
	xor	a
	jp      GetKey1

ContDown:
	ld      a,($C008)
	dec     a
	ld      ($C008),a
	out     (2),a
	xor	a
	jp      GetKey1

clrPlot:
	ld      hl,$C9FA
	ld      de,$C9FB
	ld      bc,$3FF
	ld      a,(hl)
	ldir
	ret
	
Invert:
	ld      bc,112
InvertLoop:
	ld      a,(hl)
	cpl
	ld      (hl),a
	inc     hl
	dec     bc
	ld      a,b
	or      c
	jr      nz,InvertLoop
	ret

LastPrgm:
	xor		a
	call	$514F
	xor		a
	ret		c
	call	DisplayP
	ret

NextPrgm:
	xor		a
 	call	$514B
	xor		a
	ret	    c
	call	DisplayP
	ret

DisplayP:
	ld		hl,$1D32
	ld		(_penCol),hl
	ld		hl,_OP1+2
	call	_vputs
	ld		hl,ClearLine
	call	_vputs
	xor		a
	ret

Exec:
	rst		10h
	call	$46AB
	jr		nz,BasicExec
	call	_exec_assembly
	jp		ASMstart

BasicExec:
	call	$4C57
	jp		ASMstart

ShutOff:
	ld      a,1
	out     ($03),a                                 
	ld      a, $0b
	HALT
	out     ($03),a
	res     4,(IY+$09)
	jp      ASMstart

Exit:
	call    _clrScrn
	ret

PrgmsMenu:
	.db " Program  List ",0
AbsFirst:
	.db $12,$01,$00,$00,$00,$00,$00,$00,$00,$00

ClearLine:
	.db $20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,0

EMail:  
	.db "chicane@reninet.com",0

PrgmName:
	.db "Mini-Shell",0

Version:
	.db "version .1",0
.end

